
repeat = 1;
ns = [1:1:100, 110:10:200, 300:100:1000];
ns = unique(floor(exp(log(1):0.03:log(5000))));
max_time = 1.0;
max_error = 1e-5;

time_abgabe = zeros(1, length(ns));
time_lapack = zeros(1, length(ns));
diff        = zeros(1, length(ns));
max_diff    = zeros(1, length(ns));

act_pos = 0;

for i=1:length(ns)
   act_pos = act_pos+1;

   n = ns(i)

   sumtime_abgabe = 0;
   sumtime_lapack = 0;
   sumdiff        = 0;

   for j=1:repeat
      A = randn(n);
      b = randn(n,1);

      % run Abgabe
      tic;
      fact = lr_zerlegung(A);
      x_abgabe = vor_rueck(fact, b);
      sumtime_abgabe = sumtime_abgabe + toc;

      % run LAPACK
      tic;
      x_lapack = A\b;
      sumtime_lapack = sumtime_lapack + toc;

      fehler = norm(x_abgabe-x_lapack);
      if( fehler > n*max_error )
         fehler
         save('fehler_beispiel.mat', 'A', 'b');
         disp('Die von "lr_zerlegung" und "vor_rueck" Ausgerechnete Loesung ist fehlerhaft!');
         disp(' Geben sie "load(''fehler_beispiel.mat'')" ein um A und b zu laden, welche auf das Problem gefuehrt haben.');
         error('Fehler!');
      end

      sumdiff = sumdiff + fehler;

   end

   time_abgabe(i) = sumtime_abgabe/repeat;
   time_lapack(i) = sumtime_lapack/repeat;
   diff(i)        = sumdiff/repeat;
   max_diff(i)    = n*max_error;

   if( (sumtime_abgabe+sumtime_lapack)>max_time )
      break;
   end
end

time_abgabe = time_abgabe(1:act_pos);
time_lapack = time_lapack(1:act_pos);
diff        = diff(1:act_pos);
max_diff    = max_diff(1:act_pos);
ns = ns(1:act_pos);

subplot(2,1,1);
loglog(ns, time_abgabe, 'b-', ns, time_lapack, 'r--');
legend('Mittlere Laufzeit Abgabe', 'Mittlere Laufzeit LAPACK', ...
         'Location', 'NorthWest');

subplot(2,1,2);
loglog(ns, diff, 'b-', ns, max_diff, 'k--');
legend('Fehler Abgabe<->LAPACK', 'Maximal erlaubter Fehler', ...
         'Location', 'NorthWest');
